﻿using System;
using System.Collections.ObjectModel;
using Syncfusion.SfSchedule.XForms;
using Xamarin.Forms;

namespace Schedule_UG
{
	public class CustomAppointment_SamplePage : ContentPage
	{
		SfSchedule schedule;
		Button button3;

		ScheduleAppointmentMapping dataMapping;
		ObservableCollection<Meeting> meetings;
		ScheduleViewModel viewModel;

		public CustomAppointment_SamplePage()
		{
			//creating new instance for schedule
			schedule = new SfSchedule();
			viewModel = new ScheduleViewModel();

			schedule.ScheduleView = ScheduleView.DayView;
			schedule.ShowAppointmentsInline = true;

			//AppointmentMapping
			dataMapping = new ScheduleAppointmentMapping();
			dataMapping.SubjectMapping = "EventName";
			dataMapping.StartTimeMapping = "From";
			dataMapping.EndTimeMapping = "To";
			dataMapping.ColorMapping = "color";
			schedule.AppointmentMapping = dataMapping;
			meetings = viewModel.ListOfMeeting;
			schedule.DataSource = meetings;
			schedule.OnMonthInlineAppointmentLoadedEvent += Schedule_OnMonthInlineAppointmentLoadedEvent;

			// UI View 
			StackLayout mainStack = new StackLayout();
			mainStack.Orientation = StackOrientation.Vertical;

			StackLayout buttonStack = new StackLayout();
			buttonStack.Orientation = StackOrientation.Horizontal;

			Button button1 = new Button();
			button1.Text = "day";
			button1.Clicked += Button1_Clicked;

			Button button2 = new Button();
			button2.Text = "week";
			button2.Clicked += Button2_Clicked;

			button3 = new Button();
			button3.Text = (schedule.DataSource as ObservableCollection<Meeting>).Count.ToString();
			button3.Clicked += Button3_Clicked;

			Button button4 = new Button();
			button4.Text = "month";
			button4.Clicked += Button4_Clicked;

			buttonStack.Children.Add(button1);
			buttonStack.Children.Add(button2);
			buttonStack.Children.Add(button3);
			buttonStack.Children.Add(button4);

			mainStack.Children.Add(buttonStack);
			mainStack.Children.Add(schedule);

			this.Content = mainStack;
		}

		void Schedule_OnMonthInlineAppointmentLoadedEvent(object sender, MonthInlineAppointmentLoadedEventArgs args)
		{
			Button button = new Button();
			button.Text = "CustomView";
			button.TextColor = Color.White;
			button.BackgroundColor = Color.Blue;
			args.view = button;
		}

		void Button1_Clicked(object sender, EventArgs e)
		{
			schedule.ScheduleView = ScheduleView.DayView;
		}
		void Button2_Clicked(object sender, EventArgs e)
		{
			schedule.ScheduleView = ScheduleView.WeekView;
		}
		void Button3_Clicked(object sender, EventArgs e)
		{
			button3.Text = (schedule.DataSource as ObservableCollection<Meeting>).Count.ToString();
		}
		void Button4_Clicked(object sender, EventArgs e)
		{
			schedule.ScheduleView = ScheduleView.MonthView;
		}
	}
}


